#!/usr/bin/perl -w
# -*- perl -*-

#
# $Id: Makefile.PL,v 1.4 2003/02/08 22:02:53 eserte Exp $
# Author: Slaven Rezic
#
# Copyright (C) 2002 Slaven Rezic. All rights reserved.
# This program is free software; you can redistribute it and/or
# modify it under the same terms as Perl itself.
#
# Mail: slaven.rezic@berlin.de
# WWW:  http://www.rezic.de/eserte/
#

use ExtUtils::MakeMaker;

my $ver = '0.03';
my $changes_file = parse_recent_changelog();

WriteMakefile
  (
   'NAME'	   => 'yaml-javascript',
   'VERSION'       => $ver,
   'EXE_FILES'     => [],
   'PMLIBDIRS'     => [],
   'PREREQ_PM'     => { YAML => 0.35 },

   'dist' => {'POSTOP'=>'-$(CHMOD) 644 $(DISTVNAME).tar$(SUFFIX)'},

   'ABSTRACT_FROM' => '',
   'AUTHOR'        => 'Slaven Rezic (slaven.rezic@berlin.de)',
  );

sub parse_recent_changelog {
    my $q_ver = quotemeta($ver);
    open(C, "Changes") or die $!;
    my $gather = 0;
    my $changes = "";
    while(<C>) {
	if (/^$q_ver$/) {
	    $gather = 1;
	} elsif ($gather) {
	    if (/^($|\s)/) {
		$changes .= $_;
	    } else {
		$gather = 0;
	    }
	}
    }
    close C;
    if ($changes eq '') {
	warn "No change log for version $ver found.\n";
    }
    my $changes_file = "Changes.current";
    open(CO, "> $changes_file") or die "Can't write to $changes_file: $!";
    print CO $changes;
    close CO;
    $changes_file;
}

sub MY::postamble {
    <<EOF;

release:	dist
	sf-upload -project yaml-javascript -package yaml-javascript -release \$(VERSION) -file \$(DISTVNAME).tar\$(SUFFIX) -notesfile README -changesfile $changes_file
EOF

}

__END__
