/**********************
 *
 * perl_dumper.js
 * $Id: perl_dumper.js,v 1.5 2002/10/29 14:29:35 eserte Exp $
 *
 * (c) 2001 Olaf Mtzner
 * (c) 2002 Slaven Rezic
 * This program is free software; you can redistribute it and/or modify
 * it under the same terms as Perl.
 *
 **********************************************************************/

// XXX do not use ordered hashes for now, because of problems with
// WE_Content::IxHash and Safe
PerlDumper_UseOH  = false; // use ordered hashes if true
PerlDumper_Indent = 4;
PerlDumper_PrettyPrint = false;

function PerlDumper() {
    this.stream  = "";
    this.depth   = -1;
    this.PrettyPrint = PerlDumper_PrettyPrint;
    this.UseOH       = PerlDumper_UseOH;
    this.Indent      = PerlDumper_Indent;

    this.dump    = PerlDumperDump;
    this.dump1   = PerlDumperDump;
    this._init   = PerlDumper_init;
    this._dump   = PerlDumper_dump;
    this._indent = PerlDumper_indent;
    this._escape = PerlDumper_escape;
}

function PerlDumperDump(obj, prettyprint) {
    this._init(prettyprint);
    return this._dump(obj);
}

function PerlDumper_init(prettyprint) {
    this.stream = "";
    this.depth = -1;
    if (typeof prettyprint != "undefined")
	this.PrettyPrint = prettyprint;
    this.indent_string = PerlDumper_x(" ", this.Indent);
}

function PerlDumper_dump(obj) {
    var nl = "";
    if (this.PrettyPrint) nl = "\n";
    this.depth++;
    var typ = new Object;
    if (typeof obj == "object") {
	for (var i in obj) {
	    if (isNaN(i)) {
		if (this.UseOH) {
		    typ.start = 'OH(';
		    typ.end   = ')';
		} else {
		    typ.start = '{'
			typ.end   = '}';
		}
		typ.type  = 'h'; // hash
	    } else { 
		typ.start = '[';
		typ.end   = ']';
		typ.type  = 'a'; // array
	    }
	    break;
	}
    }
    if (typeof typ.start == "undefined") {
	if (typeof obj == "object") {
	    typ.start = "[";
	    typ.end   = "]";
	    typ.type  = 'a';
	} else {
	    typ.start = "'";
	    typ.end   = "'";
	    typ.type  = 's'; // string
	}
    }
    if (typeof obj == "undefined" || obj == null) {
	this.stream += "undef," + nl;
    } else {
	this.stream += this._indent(this.depth) + typ.start + nl;
	for (var i in obj) {
	    if (typeof obj[i] == "string" || typeof obj[i] == "number") {
		if (typ.type == "h")
		    this.stream += this._indent(this.depth+1) + '"' + this._escape(i) + '" => ' + nl;
		this.stream += this._indent(this.depth+1) + '"' + (typeof obj[i] == "number" ? obj[i] : this._escape(obj[i])) + '",' + nl;
	    } else if (typeof obj[i] == "object") {
		if (typ.type == "h")
		    this.stream += this._indent(this.depth+1) + '"' + this._escape(i) + '" => ' + nl;
		this._dump(obj[i]);
	    } else {
		alert("Cannot handle " + typeof obj[i]);
	    }
	}
	this.stream += this._indent(this.depth) + typ.end + "," + nl;
    }
    this.depth--;
    return this.stream;
}

function PerlDumper_indent(n) {
    if (!this.PrettyPrint) return "";
    return PerlDumper_x(this.indent_string, n);
}

PerlDumper_escapes =
    ["\\x00", "\\x01", "\\x02", "\\x03", "\\x04", "\\x05", "\\x06", "\\a",
     "\\x08", "\\t",   "\\n",   "\\x0b", "\\f",   "\\r",   "\\x0e", "\\x0f",
     "\\x10", "\\x11", "\\x12", "\\x13", "\\x14", "\\x15", "\\x16", "\\x17",
     "\\x18", "\\x19", "\\x1a", "\\e",   "\\x1c", "\\x1d", "\\x1e", "\\x1f",
    ];

function PerlDumper_escape(text) {
    text = text.replace(/\\/g, "\\\\");
    text = text.replace(/"/g, '\\"'); // '
    text = text.replace(/@/g, '\\@');
    text = text.replace(/\$/g, '\\$');
    var new_text = "";
    for(var i = 0; i < text.length; i++) {
	if (text.charCodeAt(i) <= 0x1f) {
	    new_text += PerlDumper_escapes[text.charCodeAt(i)];
	} else {
	    new_text += text.charAt(i);
	}
    }
    return new_text;
}

function PerlDumper_x(s,n) {
    var ret = "";
    for (var i=1; i<=n; i++) {
	ret += s;
    }
    return ret;
}

