#!/usr/bin/perl -w
# -*- perl -*-

#
# $Id: data_denter.pl,v 1.2 2002/10/24 12:38:00 eserte Exp $
# Author: Slaven Rezic
#
# Copyright (C) 2002 Slaven Rezic. All rights reserved.
# This program is free software; you can redistribute it and/or
# modify it under the same terms as Perl itself.
#
# Mail: slaven.rezic@berlin.de
# WWW:  http://www.rezic.de/eserte/
#

use strict;
use Data::Denter;
use YAML ();

$/ = undef;

my $mod = "";
foreach my $js_file (qw(yaml_dumper data_denter_dumper)) {
    open(MOD, "../${js_file}.js") or die "while loading $js_file: $!";
    $mod .= <MOD>;
    close MOD;
}

open(TEST, "data_denter.js") or die $!;
my $test = <TEST>;
close TEST;

open(RUN, ">/tmp/t.js") or die $!;
print RUN "$mod\n$test\n";
close RUN;

print "\nJavascript:\n";
my $js = "js";
#my $js = "mozilla-js";
system($js, "/tmp/t.js");

my $a = [sub { warn; warn },1,0,undef,
	 "   01234567890123456789012345678901234567890123456789012345678901234567890",
	 "   01234567890123456789012345678901234567890123456789012345678901234567890\n\n\n",
	 "   01234567890123456789012345678901234567890123456789012345678901234567890\n",
	 "0123456789\n0123456789\n0123456789\n0123456789\n0123456789\n0123456789\n",
	 1,2,3,"string",undef,{foo=>"bar",x=>"zah"},4,5,6,"EOVtest\nEOV0\nEOV1",[],{}];
my $h = {foo => "bar",
	 x => "zah\nnewline\n",
	 "\"com\nplex:\"" => [1,2,3,{foo => "bar", x => "zah"},4,5,6]};
my $evil_string = join("", map { chr($_) } (0..255));
#print "\nPerl (Data-Denter):\n" . Denter $h;
print "\nPerl (YAML):\n" . YAML::Dump($a, $h, $evil_string);


__END__
